/**********************************************************************
   ̉߂ Ported from EX-SYSTEM
   $Id: Equation.c,v 1.2 1998/10/02 11:00:59 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"funcs.h"
#include	<math.h>
#include	"Equation.h"

#ifndef	PI
#define	PI	3.1415926535898
#endif

#define	ZERO_MIN	(-1.0E-5)	/* xoȂ */
#define	ZERO_MAX	(+1.0E-5)	/*  */

/* 񎟕̉߂
 * 
 *	a	Wi[̈ւ̃AhX
 *	x	i[̈ւ̃AhX
 * 		߂lQ̎͂QCO̎ɂ͎Ƌi[
 * ߂l
 *	̌
 */
int	Qadrti( double *a, double *x )
{
	double	d;
	int	result;

	d = a[1]*a[1]-4.0*a[0]*a[2];
	if( d>ZERO_MIN ){
		if( d<0.0 ) d = 0.0;
		x[0] = (-a[1]+sqrt( d ))/2.0/a[0];
		x[1] = (-a[1]-sqrt( d ))/2.0/a[0];
		result = 2;
	} else {
		x[0] = -a[1]/2.0/a[0];
		x[1] = sqrt( -d )/2.0/a[0];
		if( x[1]>ZERO_MIN && x[1]<ZERO_MAX ){
			x[1] = x[0];
			result = 2;
		} else result = 0;
	}
	qsort( x, result, sizeof(double), compare );
	return( result );
}

/* Ỏ߂
 * 
 *	a	Wi[̈ւ̃AhX
 *	x	i[̈ւ̃AhX
 * 		߂lR̎͂RCP̎ɂ͂PC𕡑f̎
 *		Ƌi[
 * ߂l
 *	̌
 */
int	Carda( double *a, double *x )
{
	double	d, p, q, r1, r2, u, v, th, tmp;
	int	result;

	p = -a[1]*a[1]/9.0/a[0]/a[0]+a[2]/3.0/a[0];
	q = 2.0*a[1]*a[1]*a[1]/27.0/a[0]/a[0]/a[0]
		-a[1]*a[2]/3.0/a[0]/a[0]+a[3]/a[0];
	d = q*q+4.0*p*p*p;
	if( d>ZERO_MIN ){
		if( d<0.0 ) d = 0.0;
		tmp = (-q+sqrt( d ))/2.0;
		if( tmp>=0.0 ) r1 = pow( tmp, 1.0/3.0 );
		else r1 = -pow( -tmp, 1.0/3.0 );
		tmp = (-q-sqrt( d ))/2.0;
		if( tmp>=0.0 ) r2 = pow( tmp, 1.0/3.0 );
		else r2 = -pow( -tmp, 1.0/3.0 );
		u = r1+r2;
		v = r1-r2;
		if( d<ZERO_MAX && d>ZERO_MIN ){
			d = 0.0;
			x[0] = u-a[1]/3.0/a[0];
			x[1] = x[2] = -u/2.0-a[1]/3.0/a[0];
			result = 3;
		} else {
			x[0] = u-a[1]/3.0/a[0];
			x[1] = -u/2.0-a[1]/3.0/a[0];
			x[2] = -sqrt( 3.0 )/2.0*v;
			if( x[2]>ZERO_MIN && x[2]<ZERO_MAX ){
				x[2] = x[1];
				result = 3;
			} else result = 1;
		}
	} else {
		th = atan2( sqrt( -d ), -q );
		x[0] = 2.0*sqrt( -p )*cos( th/3.0 )-a[1]/3.0/a[0];
		x[1] = 2.0*sqrt( -p )*cos( (th+2.0*(double)PI)/3.0 )-a[1]/3.0/a[0];
		x[2] = 2.0*sqrt( -p )*cos( (th+4.0*(double)PI)/3.0 )-a[1]/3.0/a[0];
		result = 3;
	}
	qsort( x, result, sizeof(double), compare );
	return( result );
}

/* l̉߂
 * 
 *	a	Wi[̈ւ̃AhX
 *	x	i[̈ւ̃AhX
 * 		߂lS̎͂SCQ̎ɂ͂QC𕡑f̎
 *		ƋCO̎ɂ͋𕡑f̎Ƌgi[
 * ߂l
 *	̌
 */
int	Ferra( double *a, double *x )
{
	double	d, p, q, r, th, tmp;
	double	a0[4], x0[3], y;
	int	j, k, result;

	p = -3.0*a[1]*a[1]/8.0/a[0]/a[0]+a[2]/a[0];
	q = -a[1]/2.0/a[0]*p-a[1]*a[1]*a[1]/16.0/a[0]/a[0]/a[0]+a[3]/a[0];
	r = -a[1]/8.0/a[0]*q+a[1]*a[1]*a[1]*a[1]/256.0/a[0]/a[0]/a[0]/a[0]
		-a[1]*a[3]/8.0/a[0]/a[0]+a[4]/a[0];
	if( q<ZERO_MAX && q>ZERO_MIN ){
		q = 0.0;
		d = p*p-4*r;
		if( d>ZERO_MIN ){
			if( d<0.0 ) d = 0.0;
			tmp = (sqrt( d )-p)/2.0;
			if( tmp>ZERO_MIN ){
				if( tmp<0.0 ) tmp = 0.0;
				x[0] = -a[1]/4.0/a[0]+sqrt( tmp );
				x[1] = -a[1]/4.0/a[0]-sqrt( tmp );
				tmp = (-sqrt( d )-p)/2.0;
				if( tmp>ZERO_MIN ){
					if( tmp<0.0 ) tmp = 0.0;
					x[2] = -a[1]/4.0/a[0]+sqrt( tmp );
					x[3] = -a[1]/4.0/a[0]-sqrt( tmp );
					tmp = x[1]; x[1] = x[2]; x[2] = x[3]; x[3] = tmp;
					result = 4;
				} else {
					x[2] = -a[1]/4.0/a[0];
					x[3] = sqrt( -tmp );
					result = 2;
				}
			} else {
				x[0] = x[2] = -a[1]/4.0/a[0];
				x[1] = sqrt( -tmp );
				tmp = (-sqrt( d )-p)/2.0;
				x[3] = sqrt( -tmp );
				result = 0;
			}
		} else {
			th = atan2( sqrt( -d ), -p );
			tmp = pow( r, 0.25 );
			x[0] = tmp*sin( th/2.0 );
			x[2] = -x[0];
			x[0] -= -a[1]/4.0/a[0];
			x[2] -= -a[1]/4.0/a[0];
			x[1] = x[3] = tmp*cos( th/2.0 );
			if( x[1]>ZERO_MIN && x[1]<ZERO_MAX ){
				x[1] = x[0];
				x[3] = x[2];
				result = 4;
			} else result = 0;
		}
	} else {
		a0[0] = 1;
		a0[1] = -p;
		a0[2] = -4.0*r;
		a0[3] = 4.0*r*p-q*q;
		Carda( a0, x0 );
		y = x0[0];
		a0[0] = 1;
		a0[1] = sqrt( y-p );
		a0[2] = (y-q/sqrt( y-p ))/2.0;
		j = Qadrti( a0, x0 );
		x[0] = x0[0]-a[1]/4.0/a[0];
		x[1] = (j==0)?x0[1]:x0[1]-a[1]/4.0/a[0];
		a0[0] = 1;
		a0[1] = -sqrt( y-p );
		a0[2] = (y+q/sqrt( y-p ))/2.0;
		k = Qadrti( a0, x0 );
		x[2] = x0[0]-a[1]/4.0/a[0];
		x[3] = (k==0)?x0[1]:x0[1]-a[1]/4.0/a[0];
		if( j==0 && k!=0 ){
			tmp = x[0]; x[0] = x[2]; x[2] = tmp;
			tmp = x[1]; x[1] = x[3]; x[3] = tmp;
		}
		result = j+k;
	}
	qsort( x, result, sizeof(double), compare );
	return( result );
}

int	compare( double *key1, double *key2 )
{
	return( (int)(*key2-*key1) );
}
