/*****************************************************************************
  ȃOf[V (based on EX-SYSTEM cgrad.c)
  24bit Colors modified for layman
  $Id: cgrad.c,v 1.2 1998/07/11 13:38:09 TANE Exp $
******************************************************************************/

#include	"common.h"
#include	"funcs.h"
#include	"cgrad.h"

int	cgrad(  struct VGRAM_STRUCT *vg_pt , struct CGRAD_EXEC_STRUCT *exec_info )
{
int		x1, y1, x2, y2 ;
int		xc, yc;
int		x0, y0;

int		near, far, p;
int		f[3], ff;
int		rgb_s[3] ;
int		rgb_e[3] ;
int		sgnf[3] ;
int		rgb_res ;
int		i, j ;

register short	width ;  // intɂgcc2ŃG[R[hf

	x0=exec_info->px ;
	y0=exec_info->py ;

	x1 = exec_info->x0 ;
	y1 = exec_info->y0 ;
	x2 = exec_info->x1 ;
	y2 = exec_info->y1 ;

	if( x1==x2 || y1==y2 ) return( NORMAL_EXIT );
	xc = x1+(x2-x1)/2;
	yc = y1+(y2-y1)/2;

	if( y0>=yc ){
		if( x0>=xc ){	/* ی */
			far = (x0-x1)*(x0-x1)+(y0-y1)*(y0-y1);
		} else {	/* ی */
			far = (x0-x2)*(x0-x2)+(y0-y1)*(y0-y1);
		}
	} else {
		if( x0>=xc ){	/* lی */
			far = (x0-x1)*(x0-x1)+(y0-y2)*(y0-y2);
		} else {	/* Oی */
			far = (x0-x2)*(x0-x2)+(y0-y2)*(y0-y2);
		}
	}
	if( y0<y1 ){
		if( x0<x1 ){
			near = (x0-x1)*(x0-x1)+(y0-y1)*(y0-y1);
		} else {
			if( x0>x2 ){
				near = (x0-x2)*(x0-x2)+(y0-y1)*(y0-y1);
			} else near = (y0-y1)*(y0-y1);
		}
	} else {
		if( y0>y2 ){
			if( x0<x1 ){
				near = (x0-x1)*(x0-x1)+(y0-y2)*(y0-y2);
			} else {
				if( x0>x2 ){
					near = (x0-x2)*(x0-x2)+(y0-y2)*(y0-y2);
				} else near = (y0-y2)*(y0-y2);
			}
		} else{
			if( x0<x1 ){
				near = (x0-x1)*(x0-x1);
			} else {
				if( x0>x2 ){
					near = (x0-x2)*(x0-x2);
				} else near = 0;
			}
		}
	}

	rgb_s[0] = exec_info->sb ;
	rgb_s[1] = exec_info->sr ;
	rgb_s[2] = exec_info->sg ;
	rgb_e[0] = exec_info->eb ;
	rgb_e[1] = exec_info->er ;
	rgb_e[2] = exec_info->eg ;

	f[0] = 0x10000*abs(rgb_e[0]-rgb_s[0])/(far-near);
	sgnf[0] = (rgb_e[0]>rgb_s[0])?1:-1;

	f[1] = 0x10000*abs(rgb_e[1]-rgb_s[1])/(far-near);
	sgnf[1] = (rgb_e[1]>rgb_s[1])?1:-1;

	f[2] = 0x10000*abs(rgb_e[2]-rgb_s[2])/(far-near);
	sgnf[2] = (rgb_e[2]>rgb_s[2])?1:-1;

	width = vg_pt->width ;

	for( i=y1; i<=y2; i++ ){
		for( j=x1 ; j<=x2; j++ ){

			p = (x0-j)*(x0-j)+(y0-i)*(y0-i);

			ff = (f[0]*(p-near));
			rgb_res = sgnf[0]*((ff+0x10000/2)/0x10000) + rgb_s[0];
			rgb_res = limit_max( rgb_res , VALUE_MAX ) ;
			vg_pt->pix[j+i*width].b = rgb_res ;

			ff = (f[1]*(p-near));
			rgb_res = sgnf[1]*((ff+0x10000/2)/0x10000) + rgb_s[1];
			rgb_res = limit_max( rgb_res , VALUE_MAX ) ;
			vg_pt->pix[j+i*width].r = rgb_res ;

			ff = (f[2]*(p-near));
			rgb_res = sgnf[2]*((ff+0x10000/2)/0x10000) + rgb_s[2];
			rgb_res = limit_max( rgb_res , VALUE_MAX ) ;
			vg_pt->pix[j+i*width].g = rgb_res ;
		}
	}
	return( NORMAL_EXIT ) ;
}
