/**********************************************************************
   correct ( ported from pnmgamma.c(netpbm-plus package) )
  $Id: gamma.c,v 1.4 1998/10/31 08:51:06 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"gamma.h"
#include	"funcs.h"
#include	<math.h>

void buildgamma( unsigned char* , double ) ;

int	gamma_c( struct VGRAM_STRUCT *vg_pt, struct GAMMA_EXEC_STRUCT *exec_info )
{
register short	x,y ;
short	r,g,b,a ;
short	width ;
unsigned char *r_tbl, *g_tbl, *b_tbl ;

	r_tbl = malloc( VALUE_MAX+1 ) ;
	g_tbl = malloc( VALUE_MAX+1 ) ;
	b_tbl = malloc( VALUE_MAX+1 ) ;
	if( r_tbl == NULL || g_tbl == NULL || b_tbl == NULL ){
		fprintf(stderr,"Ɨ̈mۂł܂ł") ;
		free( r_tbl ) ; free( g_tbl ) ; free( b_tbl ) ;
		return(WORK_MEM_ALLOC_ERROR) ;
	}

	buildgamma( r_tbl, exec_info->rgamma );
	buildgamma( g_tbl, exec_info->ggamma );
	buildgamma( b_tbl, exec_info->bgamma );

	width = vg_pt->width ;

	if( exec_info->mask == OFF ){
		for( y=exec_info->y0 ; y <= exec_info->y1 ; y++ ){
			for( x=exec_info->x0 ; x <=exec_info->x1 ; x++ ){
				r = vg_pt->pix[ x + y*width ].r ;
				vg_pt->pix[ x + y*width ].r = r_tbl[r] ;
				g = vg_pt->pix[ x + y*width ].g ;
				vg_pt->pix[ x + y*width ].g = g_tbl[g] ;
				b = vg_pt->pix[ x + y*width ].b ;
				vg_pt->pix[ x + y*width ].b = b_tbl[b] ;
			}
		}
	}else{
		for( y=exec_info->y0 ; y <= exec_info->y1 ; y++ ){
			for( x=exec_info->x0 ; x <=exec_info->x1 ; x++ ){
				a = vg_pt->pix[ x + y*width ].a ;
				switch( a ){
					case 0 :
						r = vg_pt->pix[ x + y*width ].r ;
						vg_pt->pix[ x + y*width ].r = r_tbl[r] ;
						g = vg_pt->pix[ x + y*width ].g ;
						vg_pt->pix[ x + y*width ].g = g_tbl[g] ;
						b = vg_pt->pix[ x + y*width ].b ;
						vg_pt->pix[ x + y*width ].b = b_tbl[b] ;
						break ;
					case VALUE_MAX :
						break ;
					default :
						r = vg_pt->pix[ x + y*width ].r ;
						vg_pt->pix[ x + y*width ].r = mix_col( r, r_tbl[r], a, VALUE_MAX ) ;
						g = vg_pt->pix[ x + y*width ].g ;
						vg_pt->pix[ x + y*width ].g = mix_col( g, g_tbl[g], a, VALUE_MAX ) ;
						b = vg_pt->pix[ x + y*width ].b ;
						vg_pt->pix[ x + y*width ].b = mix_col( b, b_tbl[b], a, VALUE_MAX ) ;
				}
			}
		}
	}

	free( r_tbl ) ;
	free( g_tbl ) ;
	free( b_tbl ) ;

	return( NORMAL_EXIT ) ;
}

/******************************************************************
   e[u̐
******************************************************************/
void buildgamma( table, gm )
unsigned char *table ;
double gm;
{
	register int i, v;
	double one_over_gm, ind ;

	if( gm==0.0 ){
		for ( i = 0 ; i < VALUE_MAX ; ++i ) table[i] = 0 ;
		table[VALUE_MAX] = VALUE_MAX ;
	}else{
		one_over_gm = 1.0 / gm;
		for ( i = 0 ; i <= VALUE_MAX ; ++i ){
			ind = ( (double) i ) / (double)VALUE_MAX;
			v = ( (double)VALUE_MAX * pow( ind, one_over_gm ) ) + 0.5;
			if ( v > VALUE_MAX ) v = VALUE_MAX ;
			table[i] = v;
		}
	}
}

