/**********************************************************************
  PCD[h
  $Id: load_pcd.c,v 1.3 1998/10/31 08:52:08 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"vg_getput.h"
#include	"ovlap.h"
#include	"funcs.h"

#define	PCD_WIDTH	768
#define	PCD_HEIGHT	512

int	load_pcd( struct VGRAM_STRUCT *vg_pt, char *file , struct LD_MODE_STRUCT *ld_md )
{
unsigned char	*Yl,*Cb,*Cr ;
unsigned char	*put_buf ;
FILE	*ifp;
struct	GETPUT_MODE	mode ;
int		x,xh,y,i,l ;
long	offset;
int		r,g,b, yl,cb,cr;
int		*y_to_rgb ;
int		*cr_to_r ;
int		*cb_to_g ;
int		*cr_to_g ;
int		*cb_to_b ;

	offset = 0x30000;	// 768*512pix f[^̎n܂

	if( (ifp = fopen( file , "rb" )) == NULL ){
		fprintf(stderr,"t@C %s I[vł܂\n",file) ;
		return(FILE_OPEN_ERROR) ;
	}
	if( fseek( ifp, offset, 0 ) ){
		fprintf(stderr, "t@CV[NG[łB\n" ) ;
		fclose(ifp) ;
		return(FILE_OPEN_ERROR) ;	// G[R[h̒ǉKv
	}

	init_mode( &mode ) ;

	Yl = malloc( PCD_WIDTH*2 ) ;
	Cb = malloc( PCD_WIDTH/2+1 ) ;
	Cr = malloc( PCD_WIDTH/2+1 ) ;
	put_buf = malloc( (3*PCD_WIDTH)*2 ) ;
	y_to_rgb = malloc(256*sizeof(y_to_rgb)) ;
	cr_to_r  = malloc(256*sizeof(cr_to_r)) ;
	cb_to_g  = malloc(256*sizeof(cb_to_g)) ;
	cr_to_g  = malloc(256*sizeof(cr_to_g)) ;
	cb_to_b  = malloc(256*sizeof(cb_to_b)) ;

	if( Yl==NULL || Cb==NULL || Cr ==NULL ||
	    y_to_rgb==NULL || cr_to_r==NULL || cb_to_g==NULL || cr_to_g==NULL || cb_to_b==NULL ){
		free(Yl) ; free(Cb) ; free(Cr) ; free(put_buf) ;
		free(y_to_rgb) ; free(cr_to_r) ; free(cb_to_g) ; free(cr_to_g) ; free(cb_to_b) ;
		fprintf(stderr,"Ɨ̈mۂł܂ł\n") ;
		return(WORK_MEM_ALLOC_ERROR) ;
	}

	/** CrCb->RGB ϊe[u(̈ꕔ) xႢȂ.... **/
	for( i=0 ; i<256 ; i++ ){
		y_to_rgb[i] = (i*1391)/1024 ;
		cr_to_r[i]  = (i*1865)/1024 ;
		cb_to_g[i]  = (i*441 )/1024 ;
		cr_to_g[i]  = (i*949 )/1024 ;
		cb_to_b[i]  = (i*2271)/1024 ;
	}

	mode.mask = ld_md->mask ;
	mode.rev  = ld_md->rev  ;
	mode.tran = ld_md->tran  ;
	switch( ld_md->oper ){
		case OVLAP_MONO :
			mode.oper = VG_TO_MONO ;
			break ;
		case OVLAP_MONOB :
			mode.oper = VG_TO_MONOB ;
			break ;
		case OVLAP_ATTR :
			mode.oper = VG_TO_A ;
			break ;
	}
	if( ld_md->vector == ROT90_LOAD ){
		int	tmpval ;
		mode.vector = VERTICAL ;
		tmpval=ld_md->px ;
		ld_md->px = ld_md->py ;
		ld_md->py = tmpval ;
	}

	for( y=0 ; y<PCD_HEIGHT ; y+=2 ){
		fread( Yl , 2 , PCD_WIDTH   , ifp ) ;
		fread( Cb , 1 , PCD_WIDTH/2 , ifp ) ;
		fread( Cr , 1 , PCD_WIDTH/2 , ifp ) ;
		Cb[PCD_WIDTH/2+1] = Cb[PCD_WIDTH/2] ;
		Cr[PCD_WIDTH/2+1] = Cr[PCD_WIDTH/2] ;

		i=0 ;
		for( l=0 ; l<2 ; l++ ){
			for( x=0 ; x<PCD_WIDTH ; x++ ){
				xh = x/2 ;
				if( (x%2) == 0 ){
					cb = Cb[xh] ;
					cr = Cr[xh] ;
				}else{
					cb = (Cb[xh] + Cb[xh+1]) / 2 ;
					cr = (Cr[xh] + Cr[xh+1]) / 2 ;
				}
				yl = Yl[x+l*PCD_WIDTH] ;
//				r = (1391*yl + 1865*cr - 255023)/1024 ;
//				g = (1391*yl -  441*cb - 949*cr +199313)/1024 ;
//				b = (1391*yl + 2271*cb - 353784)/1024 ;
				r = (y_to_rgb[yl] + cr_to_r[cr]) - (255023/1024) ;
				g = (y_to_rgb[yl] - cb_to_g[cb] - cr_to_g[cr]) + (199313/1024) ;
				b = (y_to_rgb[yl] + cb_to_b[cb]) - (353784/1024) ;
				put_buf[i++]=limit_minmax(r,0,VALUE_MAX) ;
				put_buf[i++]=limit_minmax(g,0,VALUE_MAX) ;
				put_buf[i++]=limit_minmax(b,0,VALUE_MAX) ;
			}
		}
		vg_put_rect( vg_pt , put_buf , ld_md->px , ld_md->py+y , PCD_WIDTH , 2 , &mode ) ;
	}

	fclose(ifp) ;
	free(Yl) ; free(Cb) ; free(Cr) ; free(put_buf) ;
	free(y_to_rgb) ; free(cr_to_r) ; free(cb_to_g) ; free(cr_to_g) ; free(cb_to_b) ;
	return( NORMAL_EXIT ) ;
}

