/**********************************************************************
  noise sC
  $Id: noise.c,v 1.1 1998/08/28 15:52:29 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"noise.h"
#include	"funcs.h"
#include	"hsv_rgb.h"

int	noise( struct VGRAM_STRUCT *vg_pt, struct NOISE_EXEC_STRUCT *exec_info )
{
int		x,y ;
int		width ;
int		r,g,b ;
int		h,s,v ;
int		mask ;
int		n ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	width = vg_pt->width ;

	switch( exec_info->oper ){
		case NORMAL_NOISE :
			for( y=exec_info->y0 ; y<=exec_info->y1 ; y++ ){
				for( x=exec_info->x0 ; x<=exec_info->x1 ; x++ ){
					if( exec_info->rev == ON ) mask = VALUE_MAX - pix_pt[x+y*width].a ;
					else                       mask = pix_pt[x+y*width].a ;
					n=(((int)random() % exec_info->level) - (exec_info->level/2) ) * exec_info->level ;
					r = limit_minmax((int)pix_pt[x+y*width].r + n ,0,VALUE_MAX);
					pix_pt[x+y*width].r = mix_col( (int)pix_pt[x+y*width].r, r, mask, VALUE_MAX );

					n=(((int)random() % exec_info->level) - (exec_info->level/2) ) * exec_info->level ;
					g = limit_minmax((int)pix_pt[x+y*width].g + n ,0,VALUE_MAX);
					pix_pt[x+y*width].g = mix_col( (int)pix_pt[x+y*width].g, g, mask, VALUE_MAX );

					n=(((int)random() % exec_info->level) - (exec_info->level/2) ) * exec_info->level ;
					b = limit_minmax((int)pix_pt[x+y*width].b + n ,0,VALUE_MAX);
					pix_pt[x+y*width].b = mix_col( (int)pix_pt[x+y*width].b, b, mask, VALUE_MAX );
				}
			}
			break ;

		case HUE_NOISE :
			for( y=exec_info->y0 ; y<=exec_info->y1 ; y++ ){
				for( x=exec_info->x0 ; x<=exec_info->x1 ; x++ ){
					if( exec_info->rev == ON ) mask = VALUE_MAX - pix_pt[x+y*width].a ;
					else                       mask = pix_pt[x+y*width].a ;
					RGBtoHSV( pix_pt[x+y*width].r, pix_pt[x+y*width].g, pix_pt[x+y*width].b, &h, &s, &v );
					h += HUE_RANGE ;
					/*** level *4 ͂ȂƂȂĂ邾 ***/
					h -= (((int)random() % exec_info->level*4) ) * exec_info->level ;
					h = (h % HUE_RANGE) ;
					HSVtoRGB( h, s, v, &r, &g, &b );
					pix_pt[x+y*width].r = mix_col( (int)pix_pt[x+y*width].r, r, mask, VALUE_MAX );
					pix_pt[x+y*width].g = mix_col( (int)pix_pt[x+y*width].g, g, mask, VALUE_MAX );
					pix_pt[x+y*width].b = mix_col( (int)pix_pt[x+y*width].b, b, mask, VALUE_MAX );
				}
			}
			break ;

		case VAL_NOISE :
			for( y=exec_info->y0 ; y<=exec_info->y1 ; y++ ){
				for( x=exec_info->x0 ; x<=exec_info->x1 ; x++ ){
					if( exec_info->rev == ON ) mask = VALUE_MAX - pix_pt[x+y*width].a ;
					else                       mask = pix_pt[x+y*width].a ;
					RGBtoHSV( pix_pt[x+y*width].r, pix_pt[x+y*width].g, pix_pt[x+y*width].b, &h, &s, &v );
					v -= ((int)random() % exec_info->level ) * exec_info->level ;
					v = limit_minmax( v, 0, VALUE_MAX ) ;
					HSVtoRGB( h, s, v, &r, &g, &b );
					pix_pt[x+y*width].r = mix_col( (int)pix_pt[x+y*width].r, r, mask, VALUE_MAX );
					pix_pt[x+y*width].g = mix_col( (int)pix_pt[x+y*width].g, g, mask, VALUE_MAX );
					pix_pt[x+y*width].b = mix_col( (int)pix_pt[x+y*width].b, b, mask, VALUE_MAX );
				}
			}
			break ;

		case SAT_NOISE :
			for( y=exec_info->y0 ; y<=exec_info->y1 ; y++ ){
				for( x=exec_info->x0 ; x<=exec_info->x1 ; x++ ){
					if( exec_info->rev == ON ) mask = VALUE_MAX - pix_pt[x+y*width].a ;
					else                       mask = pix_pt[x+y*width].a ;
					RGBtoHSV( pix_pt[x+y*width].r, pix_pt[x+y*width].g, pix_pt[x+y*width].b, &h, &s, &v );
					s -= ((int)random() % exec_info->level) * exec_info->level ; ;
					s = limit_max( s, VALUE_MAX ) ;
					HSVtoRGB( h, s, v, &r, &g, &b );
					pix_pt[x+y*width].r = mix_col( (int)pix_pt[x+y*width].r, r, mask, VALUE_MAX );
					pix_pt[x+y*width].g = mix_col( (int)pix_pt[x+y*width].g, g, mask, VALUE_MAX );
					pix_pt[x+y*width].b = mix_col( (int)pix_pt[x+y*width].b, b, mask, VALUE_MAX );
				}
			}
			break ;
	}

	return( NORMAL_EXIT ) ;
}
