/**********************************************************************
  pers sC
  $Id: pers.c,v 1.3 1998/10/24 13:33:25 TANE Exp $
**********************************************************************/
/*
 *	rendF.c
 *	- _O(S)
 *	  Mar. 1995 - Jun. 1995
 *	  O@F (Oh!X)
 *
 *  layman modified by TANE
 */

#include	"common.h"
#include	"pers.h"
#include	"funcs.h"
#include	"math3D.h"
#include	"composit.h"

extern vec3	center;	/* g̒S */
extern mat3	A, A_;	/* SXebv̍sEts */
extern mat3	B, B_;	/* OXebv̍sEts */
extern mat3	C, C_;	/* e|̍sEts */

void	cross( int*, int*, int*, int, int, int, int, int, int ) ;
extern void	pers( struct VGRAM_STRUCT *, int*, int*, int*, vec3* );
extern void	prepareInvPers();
extern int	getTexelBilinear( struct VGRAM_STRUCT *, CompositInfo*, int, int, int, int );

int	pers_main( struct VGRAM_STRUCT *vg_pt, struct PERS_EXEC_STRUCT *exec_info )
{
vec3	tmpv;
int		x1, y1, z1, x2, y2, z2, x3, y3, z3;
int		a, b, c, d;
int		x, y, z, i ;
CompositInfo	ci;
struct	VGRAM_STRUCT	vg_tmp ;
struct	VGRAM_STRUCT	*vg_tmp_pt ;
struct	PIX_STRUCT		*dst_pix ;

	center[0] = exec_info->ox;	/* x */
	center[1] = exec_info->oy;	/* y */
	center[2] = exec_info->oz;	/* z */
	unitM3( &A );
	unitM3( &A_ );
	unitM3( &B );
	unitM3( &B_ );
	unitM3( &C );
	unitM3( &C_ );

	xrotM3( &B, &B_, exec_info->tx ); /* x Sɉ */
	prodMM3( &C, &B, &A ); copyM3( &A, &C );
	prodMM3( &C_, &A_, &B_ ); copyM3( &A_, &C_ );
	yrotM3( &B, &B_, exec_info->ty ); /* y Sɉ */
	prodMM3( &C, &B, &A ); copyM3( &A, &C );
	prodMM3( &C_, &A_, &B_ ); copyM3( &A_, &C_ );
	zrotM3( &B, &B_, exec_info->tz ); /* z Sɉ */
	prodMM3( &C, &B, &A ); copyM3( &A, &C );
	prodMM3( &C_, &A_, &B_ ); copyM3( &A_, &C_ );

	vg_tmp_pt = &vg_tmp ;
	vg_alloc( vg_tmp_pt , vg_pt->width , vg_pt->height ) ;
	if( vg_tmp_pt->pix == NULL ){
		fprintf(stderr,"Ɨ̈̊mۂɎs܂\n") ;
		return( VGRAM_WORK_ALLOC_ERROR ) ;
	}
	vg_cpy( vg_tmp_pt , vg_pt ) ;
	dst_pix = vg_pt->pix ;

	/* tϊɗpW[v̊Oŋ߂ */
	prepareInvPers();

#define	EPS	(512.0)
	/* Kԓ̕ʕ߂ */
	tmpv[0] = 0.0; tmpv[1] = 0.0; tmpv[2] = 0.0;
	pers( vg_pt, &x1, &y1, &z1, &tmpv );
	tmpv[0] = EPS; tmpv[1] = 0.0; tmpv[2] = 0.0;
	pers( vg_pt, &x2, &y2, &z2, &tmpv );
	tmpv[0] = 0.0; tmpv[1] = EPS; tmpv[2] = 0.0;
	pers( vg_pt, &x3, &y3, &z3, &tmpv );
	cross( &a, &b, &c, x2-x1, y2-y1, z2-z1, x3-x1, y3-y1, z3-z1 );
	if ( c == 0 ){	/* Zɕsȕʂ͕`悵Ȃ */
		vg_free( vg_tmp_pt ) ;
		return( NORMAL_EXIT ) ;
	}
	d = -( a*x1 + b*y1 + c*z1 );

	for ( y = 0; y < vg_pt->height ; y++ ) {
		i = y * vg_pt->width ;
		for ( x = 0; x < vg_pt->width; x++ ) {
			z = -( a*x + b*y + d )/c;
			if ( z <= 0 ) continue;		/*  */
			if ( z >= NEARCLIPZ ) continue;	/* jANbv */
			getTexelBilinear( vg_tmp_pt, &ci, x, y, z, 1 ) ;
			dst_pix[i+x].r = ci.r ;
			dst_pix[i+x].g = ci.g ;
			dst_pix[i+x].b = ci.b ;
			dst_pix[i+x].a = ci.a ;
		}
	}

	vg_free( vg_tmp_pt ) ;

	return( NORMAL_EXIT ) ;
}

/* xNg̊O */
void	cross( int *x, int *y, int *z, int x1, int y1, int z1, int x2, int y2, int z2 )
{
	*x = y1*z2 - y2*z1;
	*y = z1*x2 - z2*x1;
	*z = x1*y2 - x2*y1;
	return;
}
