/**********************************************************************
  2D}bsO
  $Id: ring.c,v 1.1 1998/11/13 14:46:22 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"math.h"
#include	"ring.h"
#include	"funcs.h"

int	ring( struct VGRAM_STRUCT *vg_pt, struct RING_EXEC_STRUCT *exec_info )
{
int		x,y ;
int		c0, c1 ; /** FϒԌ **/
int		r00,r01,r10,r11 ;
int		g00,g01,g10,g11 ;
int		b00,b01,b10,b11 ;
int		a00,a01,a10,a11 ;
int		tran_x , tran_y ;
int		pix_adr00,pix_adr10,pix_adr01,pix_adr11 ;
struct	VGRAM_STRUCT	vg_tmp, *vg_tmp_pt ;
struct	PIX_STRUCT		*src_pix, *dst_pix ;

int		px ,py ;	//`sNZXYWn
double	p_r,p_th ;	//`sNZ̋ɍWn
int		pm_x, pm_y ;	//eNX`̍W
int		tex_w,tex_h ;

	vg_tmp_pt = &vg_tmp ;
	vg_alloc( vg_tmp_pt , vg_pt->width , vg_pt->height ) ;
	if( vg_tmp_pt->pix == NULL ){
		fprintf(stderr,"Ɨ̈̊mۂɎs܂\n") ;
		return( VGRAM_WORK_ALLOC_ERROR ) ;
	}
	vg_cpy( vg_tmp_pt , vg_pt ) ;

	src_pix = vg_tmp_pt->pix ;
	dst_pix = vg_pt->pix ;

	tex_w = exec_info->mx1 - exec_info->mx0 ;
	tex_h = exec_info->my1 - exec_info->my0 ;

	for( y=0 ; y<vg_pt->height ; y++ ){
		for( x=0 ; x<vg_pt->width ; x++ ){
			px= x - exec_info->ox ;
			py= y - exec_info->oy ;
			p_r =sqrt( (double)( px*px + py*py ) ) ;
			if( p_r<exec_info->ri || p_r>exec_info->ro ) continue ;

			/** px=0̎atanl̕␳ **/
			if( px==0 ) p_th=PI/2.0 * isgn(py) ;
			else        p_th=atan( (double)py/(double)px ) ;

			/** یɑΉatanl̕␳ **/
			if( py<0 ){
				if( px<0 ) p_th = PI      +p_th ;
				else       p_th = (2.0*PI)+p_th ;
			}else{
				if( px<0 ) p_th = PI      +p_th ;
			}
			p_th = fmod((p_th+exec_info->t),(2.0*PI)) ;

			/** eNX`Wւ̕ϊ(256{̃Q^) **/
			pm_y = ((p_r - exec_info->ri)*tex_h*256)/(exec_info->ro - exec_info->ri) ;
			pm_x = ((double)tex_w * exec_info->rep * p_th * 256.0)/(2.0*PI) ;
			pm_x = (tex_w*256) - (pm_x % (tex_w*256)) ;

			/** 4sNZ F & ` **/
			tran_x = iabs(pm_x % 256) ;
			tran_y = iabs(pm_y % 256) ;
			pm_x   = pm_x/256 ;
			pm_y   = pm_y/256 ;

			pix_adr00=pm_x   + pm_y   * vg_pt->width ;
			pix_adr10=pm_x+1 + pm_y   * vg_pt->width ;
			pix_adr01=pm_x   +(pm_y+1)* vg_pt->width ;
			pix_adr11=pm_x+1 +(pm_y+1)* vg_pt->width ;

			r00=src_pix[pix_adr00].r ;
			r10=src_pix[pix_adr10].r ;
			r01=src_pix[pix_adr01].r ;
			r11=src_pix[pix_adr11].r ;
			c0=mix_col( r10 , r00 , tran_x , VALUE_MAX ) ;
			c1=mix_col( r11 , r01 , tran_x , VALUE_MAX ) ;
			dst_pix[x+y*vg_pt->width].r = mix_col( c1, c0, tran_y, VALUE_MAX ) ;

			g00=src_pix[pix_adr00].g ;
			g10=src_pix[pix_adr10].g ;
			g01=src_pix[pix_adr01].g ;
			g11=src_pix[pix_adr11].g ;
			c0=mix_col( g10 , g00 , tran_x , VALUE_MAX ) ;
			c1=mix_col( g11 , g01 , tran_x , VALUE_MAX ) ;
			dst_pix[x+y*vg_pt->width].g = mix_col( c1, c0, tran_y, VALUE_MAX ) ;

			b00=src_pix[pix_adr00].b ;
			b10=src_pix[pix_adr10].b ;
			b01=src_pix[pix_adr01].b ;
			b11=src_pix[pix_adr11].b ;
			c0=mix_col( b10 , b00 , tran_x , VALUE_MAX ) ;
			c1=mix_col( b11 , b01 , tran_x , VALUE_MAX ) ;
			dst_pix[x+y*vg_pt->width].b = mix_col( c1, c0, tran_y, VALUE_MAX ) ;

			a00=src_pix[pix_adr00].a ;
			a10=src_pix[pix_adr10].a ;
			a01=src_pix[pix_adr01].a ;
			a11=src_pix[pix_adr11].a ;
			c0=mix_col( a10 , a00 , tran_x , VALUE_MAX ) ;
			c1=mix_col( a11 , a01 , tran_x , VALUE_MAX ) ;
			dst_pix[x+y*vg_pt->width].a = mix_col( c1, c0, tran_y, VALUE_MAX ) ;

		}
	}

	vg_free( vg_tmp_pt ) ;

	return( NORMAL_EXIT ) ;
}
