/**********************************************************************
  PNGZ[u
  $Id: save_png.c,v 1.6 1998/11/13 14:47:29 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"vg_getput.h"
#include	"save.h"
#include	"funcs.h"
#include	"png.h"

typedef struct
{
	int	interlaced;
	int	compression_level;
} PngSaveVals;

int	save_png( struct VGRAM_STRUCT *vg_pt, char *file , struct SV_MODE_STRUCT *sv_md )
{
int		y ;
int		bpp ;			/* Bytes per pixel */
int		num_passes ;	/* Number of interlace passes in file */
int		pass ;			/* Current pass in file */
FILE	*fp;		/* File pointer */

png_structp	pp;		/* PNG read pointer */
png_infop	info;		/* PNG info pointer */
PngSaveVals	pngvals = { 0, 9 } ;
int		num_colors;	/* Number of colors in colormap */

struct	GETPUT_MODE	mode ;
unsigned char	*pixel_buf[2] ;
unsigned char	**pixels ;

 if( strcmp( file , (char*)"-" ) == 0 ){
   setmode( fileno(stdout),O_BINARY ) ;
   fp = stdout ;
 }else{
   if( (fp = fopen( file , "wb" )) == NULL ){
     fprintf(stderr,"o̓t@C %s I[vł܂\n",file) ;
     return(FILE_OPEN_ERROR) ;
   }
 }
 
 init_mode( &mode ) ;
 
 pp   = png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
 if( pp==NULL ){
   fprintf(stderr,"Ɨ̈mۂł܂ł(on libpng)\n") ;
   return(WORK_MEM_ALLOC_ERROR) ;
 }
 info = png_create_info_struct(pp);
 if( info==NULL ){
   png_destroy_write_struct(&pp,(png_infopp)NULL);
   fprintf(stderr,"Ɨ̈mۂł܂ł(on libpng)\n") ;
   return(WORK_MEM_ALLOC_ERROR) ;
 }
 
 png_init_io(pp, fp);
 
 png_set_compression_level(pp, sv_md->compression_level);
 
 info->width          = (sv_md->x1 - sv_md->x0 + 1) ;
 info->height         = (sv_md->y1 - sv_md->y0 + 1) ;
 info->bit_depth      = 8;
 info->gamma          = 0.45 ; //gimp_gamma();
 info->sig_bit.red    = 8;
 info->sig_bit.green  = 8;
 info->sig_bit.blue   = 8;
 info->sig_bit.gray   = 8;
 info->sig_bit.alpha  = 8;
 info->interlace_type = pngvals.interlaced;
 info->valid          |= PNG_INFO_gAMA;
 
 switch( sv_md->save_type ){
 case SAVE_RGB_IMAGE :
   info->color_type = PNG_COLOR_TYPE_RGB;
   bpp              = 3;
   mode.buf_type    = RGB_8BIT ;
   break;
 case SAVE_RGBA_IMAGE :
   info->color_type = PNG_COLOR_TYPE_RGB_ALPHA;
   bpp              = 4;
   mode.buf_type    = RGBA_8BIT ;
   break;
 case SAVE_GRAY_IMAGE :
   info->color_type = PNG_COLOR_TYPE_GRAY;
   bpp              = 1;
   mode.buf_type    = GRAY_8BIT ;
   break;
 case SAVE_GRAYA_IMAGE :
   info->color_type = PNG_COLOR_TYPE_GRAY_ALPHA;
   bpp              = 2;
   mode.buf_type    = GRAY_8BIT ;
   break;
 case SAVE_INDEX_IMAGE :
   num_colors = 256 ;
   info->valid      |= PNG_INFO_PLTE;
   info->color_type = PNG_COLOR_TYPE_PALETTE;
   //			info->palette    = (png_colorp)gimp_image_get_cmap(image_ID, &num_colors);
   info->num_palette= num_colors;
   bpp              = 1;
   break;
 default :		/*** 璷R[h ***/
   info->color_type = PNG_COLOR_TYPE_RGB;
   bpp              = 3;
   mode.buf_type    = RGB_8BIT ;
   break;
 }
 
 pixel_buf[0] = malloc( (sv_md->x1 - sv_md->x0+1) * bpp ) ;
 if( pixel_buf[0]== NULL ){
   fprintf(stderr,"Ɨ̈mۂł܂ł\n") ;
   png_destroy_write_struct(&pp,&info);
   return(WORK_MEM_ALLOC_ERROR) ;
 }
 
 png_write_info(pp, info);
 
 if( pngvals.interlaced )
   num_passes = png_set_interlace_handling(pp);
 else
   num_passes = 1;
 
 pixels = &pixel_buf[0] ;
 for( pass = 0; pass < num_passes; pass++ ){
   for( y=sv_md->y0 ; y< (sv_md->y1+1) ; y++ ){
     vg_get_rect( vg_pt , pixel_buf[0] , sv_md->x0 , y , info->width , 1 , &mode ) ;
     png_write_rows( pp, pixels, 1 );
   }
 }
 
 png_write_end(pp, info);
 png_destroy_write_struct(&pp,&info);
 
 free( pixel_buf[0] ) ;
 
 if( fp != stdout ){
   fclose(fp);
 }else{
   setmode( fileno(stdout),O_TEXT ) ;
 }
 
 return( NORMAL_EXIT );
}
