/**********************************************************************
  RGBZ[u
  $Id: save_rgb.c,v 1.11 1998/11/20 15:11:51 TANE Exp $
**********************************************************************/

#include	"common.h"
#include	"filetype.h"
#include	"vg_getput.h"
#include	"save.h"
#include	"funcs.h"

#define	FNAME_LENG	1024
#define	FILE_NUM	64
#define	RGB_COL_DEPTH	3
#define	BUFF_DIV_MAX	1024

int	save_rgb( struct VGRAM_STRUCT *vg_pt, char *file , struct SV_MODE_STRUCT *sv_md )
{
FILE	*ofp ;
gzFile	ogzfp ;
char	gzfmode[8] ;
int		n , y ;
int		buff_size ;
int		buff_div_num ;	/*** Height ***/
int		oper_line_num ;
char	out_file[256] ;
short	width,height ;
struct	GETPUT_MODE	mode ;
struct	PIX_STRUCT	*pix_pt ;
unsigned char	*out_img_pt ;

 buff_size  = 0 ;
 out_img_pt = NULL ;
 width  = sv_md->x1 - sv_md->x0 + 1 ;
 height = sv_md->y1 - sv_md->y0 + 1 ;
 for( buff_div_num=1 ; buff_div_num<=BUFF_DIV_MAX ; buff_div_num += buff_div_num ){
   buff_size = width * (height/buff_div_num) * RGB_COL_DEPTH ;
   out_img_pt = malloc( buff_size ) ;
   if( out_img_pt != NULL ) break ;
 }
 
 if( out_img_pt == NULL ){
   fprintf(stderr,"Ɨ̈mۂł܂ł") ;
   fprintf(stderr,"saveR}h̎sɎs܂\n") ;
   return(WORK_MEM_ALLOC_ERROR) ;
 }
 
 ofp   = NULL ;
 ogzfp = NULL ;
 /*** IPRt@Co ***/
 strcpy( out_file , file ) ;
 if( strcmp( out_file , (char*)"-" ) != 0 ){
   if( (sv_md->fmt & GZIPED_FILE)==0 ){
     cut_ext( out_file ) ;
     strcat( out_file , ".IPR\0" ) ;
     if( (ofp = fopen( out_file , "wb" )) == NULL ){
       fprintf(stderr,"o̓t@C %s I[vł܂\n",out_file) ;
       return(FILE_OPEN_ERROR) ;
     }
     fprintf( ofp , "%d %d 0 0\n", width, height) ;
     fclose( ofp ) ;
   }else{
     cut_ext( out_file ) ;
     cut_ext( out_file ) ;
     strcat( out_file , ".IPR"GZ_SUFFIX ) ;
     sprintf( gzfmode, "wb%d",sv_md->compression_level ) ;
     if( (ogzfp = gzopen( out_file , gzfmode )) == NULL ){
       fprintf(stderr,"o̓t@C %s I[vł܂\n",out_file) ;
       return(FILE_OPEN_ERROR) ;
     }
     gzprintf( ogzfp , "%d %d 0 0\n", width, height) ;
     gzclose( ogzfp ) ;
   }
 }
 
 /*** RGBt@Co ***/
 if( strcmp( file , (char*)"-" ) == 0 ){
   setmode( fileno(stdout),O_BINARY ) ;
   ofp = stdout ;
 }else{
   if( (sv_md->fmt & GZIPED_FILE)==0 ){
     if( (ofp = fopen( file , "wb" )) == NULL ){
       fprintf(stderr,"o̓t@C %s I[vł܂\n",file) ;
       return(FILE_OPEN_ERROR) ;
     }
   }else{
     sprintf( gzfmode, "wb%d",sv_md->compression_level ) ;
     if( (ogzfp = gzopen( file , gzfmode )) == NULL ){
       fprintf(stderr,"o̓t@C %s I[vł܂\n",file) ;
       return(FILE_OPEN_ERROR) ;
     }
   }
 }
 
 init_mode( &mode ) ;
 
 pix_pt = vg_pt->pix ;
 oper_line_num = height / buff_div_num ;
 y = sv_md->y0 ;
 for( n=0 ; n<=buff_div_num ; n++ ){
   if( n == buff_div_num ){ /***ubN[vZ***/
     if( (height % buff_div_num) == 0 ) break ; /***[ꍇ***/
     buff_size = width * (height % buff_div_num) * RGB_COL_DEPTH ;
     oper_line_num = height % buff_div_num ;
   }
   vg_get_rect( vg_pt , out_img_pt , sv_md->x0 , y , width , oper_line_num , &mode ) ;
   if( (sv_md->fmt & GZIPED_FILE)==0 ){
     fwrite( out_img_pt , buff_size , 1 , ofp ) ;
   }else{
     gzwrite( ogzfp , out_img_pt , buff_size ) ;
   }
   y += oper_line_num ;
 }
 
 if( (sv_md->fmt & GZIPED_FILE)==0 ){
   if( ofp != stdout ){
     fclose( ofp ) ;
   }else{
     setmode( fileno(stdout),O_TEXT ) ;
   }
 }else{
   gzclose( ogzfp ) ;
 }
 free( out_img_pt ) ;
 return( NORMAL_EXIT ) ;
}
