/**********************************************************************
  sinwave sC
  $Id: sinwave.c,v 1.4 1998/10/31 08:57:34 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"vg_getput.h"
#include	"sinwave.h"
#include	"funcs.h"
#include	<math.h>

#ifndef	PI
#define	PI	3.1415926535898
#endif

int	sinwave( struct VGRAM_STRUCT *vg_pt, struct SINWAVE_EXEC_STRUCT *exec_info )
{
short	x,y,n ;
short	width , height ;
short	area_width , area_height ;	/** XN[GA̕/ **/
struct	GETPUT_MODE	mode ;
int		sin_tbl ;
struct	PIX_STRUCT	*buf_src, *buf_dst ;

	init_mode( &mode ) ;
	mode.buf_type = RGBA_8BIT ;
	mode.mask = OFF ;

	width  = vg_pt->width ;
	height = vg_pt->height ;
	area_width  = exec_info->x1 - exec_info->x0 + 1 ;
	area_height = exec_info->y1 - exec_info->y0 + 1 ;

	buf_src = NULL ;
	buf_dst = NULL ;

	if( exec_info->oper == ROLL_WAVE ){
		exec_info->t = PI*2/area_height * exec_info->t ;
		exec_info->th= PI*2/area_height * exec_info->th ;
		buf_src = malloc( area_width*sizeof(struct PIX_STRUCT) ) ;
		buf_dst = malloc( area_width*sizeof(struct PIX_STRUCT) ) ;
		if( buf_src==NULL || buf_dst==NULL ){
			fprintf(stderr,"Ɨ̈mۂł܂ł\n") ;
			free( buf_src ) ; free( buf_dst ) ;
			return(WORK_MEM_ALLOC_ERROR) ;
		}

		for( y=exec_info->y0,n=0 ; y <= exec_info->y1 ; y++,n++ ){
			vg_get_rect( vg_pt , buf_src , exec_info->x0 , y, area_width , 1 , &mode ) ;
			sin_tbl = (int)( exec_info->l * sin( n*exec_info->t+exec_info->th ) ) ;
			for( x=0 ; x<area_width ; x++ ){
				buf_dst[x] = buf_src[ ((x+area_width)+sin_tbl) % area_width ] ;
			}
			vg_put_rect( vg_pt , buf_dst , exec_info->x0 , y, area_width , 1 , &mode ) ;
		}
	}
	else if( exec_info->oper == PITCH_WAVE ){
		exec_info->t = PI*2/area_width * exec_info->t ;
		exec_info->th= PI*2/area_width * exec_info->th ;
		buf_src = malloc( area_height*sizeof(struct PIX_STRUCT) ) ;
		buf_dst = malloc( area_height*sizeof(struct PIX_STRUCT) ) ;
		if( buf_src==NULL || buf_dst==NULL ){
			fprintf(stderr,"Ɨ̈mۂł܂ł\n") ;
			free( buf_src ) ; free( buf_dst ) ;
			return(WORK_MEM_ALLOC_ERROR) ;
		}

		for( x=exec_info->x0,n=0 ; x <= exec_info->x1 ; x++,n++ ){
			vg_get_rect( vg_pt , buf_src , x , exec_info->y0, 1 , area_height , &mode ) ;
			sin_tbl = (int)( exec_info->l * sin( n*exec_info->t+exec_info->th ) ) ;
			for( y=0 ; y<area_height ; y++ ){
				buf_dst[y] = buf_src[ ((y+area_height)+sin_tbl) % area_height ] ;
			}
			vg_put_rect( vg_pt , buf_dst , x , exec_info->y0, 1 , area_height , &mode ) ;
		}
	}

	free( buf_src ) ;
	free( buf_dst ) ;

	return( NORMAL_EXIT ) ;
}
