/**********************************************************************
  vg_get_rect
  $Id: vg_get_rect.c,v 1.1 1998/10/02 11:13:12 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"funcs.h"
#include	"vg_getput.h"

void get_rgb_8bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void get_rgba_8bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void get_rgb_16bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void get_rgba_16bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void get_gray_8bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void get_gray_16bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void get_mask_8bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;
void get_mask_16bit	( struct VGRAM_STRUCT *, void *,int,int,int,int, struct GETPUT_MODE *) ;

/**********************************************************************/
int	vg_get_rect( struct VGRAM_STRUCT *vg_pt, void *buf,
                 int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
struct	MODE_TBL_STRUCT{
	void (*func)() ;
} ;
static	struct	MODE_TBL_STRUCT	getput_mode_tbl[] ={
	{ get_rgb_8bit }	,
	{ get_rgba_8bit }	,
	{ get_rgb_16bit }	,
	{ get_rgba_16bit }	,
	{ get_gray_8bit }	,
	{ get_gray_16bit }	,
	{ get_mask_8bit }	,
	{ get_mask_16bit }
} ;

	(*getput_mode_tbl[mode->buf_type].func)( vg_pt, buf, sx, sy, width, height, mode ) ;
	return( NORMAL_EXIT ) ;
}

/**********************************************************************/
void get_rgb_8bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                  int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
unsigned char	*uc_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	uc_buf = buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		for( x=sx ; x<sx+width ; x++ ){
			uc_buf[i++] = pix_pt[x+y*vg_pt->width].r ;
			uc_buf[i++] = pix_pt[x+y*vg_pt->width].g ;
			uc_buf[i++] = pix_pt[x+y*vg_pt->width].b ;
		}
	}
}

/**********************************************************************/
void get_rgba_8bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                   int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
struct	PIX_STRUCT	*pix_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	pix_buf= buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		for( x=sx ; x<sx+width ; x++ ){
			pix_buf[i++] = pix_pt[x+y*vg_pt->width] ;
		}
	}
}

/**********************************************************************/
void get_rgb_16bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                   int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
unsigned short	*us_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	us_buf = buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		for( x=sx ; x<sx+width ; x++ ){
			us_buf[i++] = pix_pt[x+y*vg_pt->width].r * 256 ;
			us_buf[i++] = pix_pt[x+y*vg_pt->width].g * 256 ;
			us_buf[i++] = pix_pt[x+y*vg_pt->width].b * 256 ;
		}
	}
}

/**********************************************************************/
void get_rgba_16bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                    int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
unsigned short	*us_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	us_buf = buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		for( x=sx ; x<sx+width ; x++ ){
			us_buf[i++] = pix_pt[x+y*vg_pt->width].r * 256 ;
			us_buf[i++] = pix_pt[x+y*vg_pt->width].g * 256 ;
			us_buf[i++] = pix_pt[x+y*vg_pt->width].b * 256 ;
			us_buf[i++] = pix_pt[x+y*vg_pt->width].a * 256 ;
		}
	}
}

/**********************************************************************/
void get_gray_8bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                   int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
unsigned char	*uc_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	uc_buf = buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		for( x=sx ; x<sx+width ; x++ ){
			uc_buf[i++] = monoconv( pix_pt[x+y*vg_pt->width].r,
			                        pix_pt[x+y*vg_pt->width].g,
			                        pix_pt[x+y*vg_pt->width].b ) ;
		}
	}
}

/**********************************************************************/
void get_gray_16bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                    int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
unsigned short	*us_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	us_buf = buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		for( x=sx ; x<sx+width ; x++ ){
			us_buf[i++] = monoconv( pix_pt[x+y*vg_pt->width].r,
			                        pix_pt[x+y*vg_pt->width].g,
			                        pix_pt[x+y*vg_pt->width].b ) * 256 ;
		}
	}
}

/**********************************************************************/
void get_mask_8bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                   int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
unsigned char	*uc_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	uc_buf = buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		for( x=sx ; x<sx+width ; x++ ){
			uc_buf[i++] = pix_pt[x+y*vg_pt->width].a ;
		}
	}
}

/**********************************************************************/
void get_mask_16bit( struct VGRAM_STRUCT *vg_pt, void *buf,
                    int sx, int sy, int width, int height, struct GETPUT_MODE *mode )
{
short	x,y ;
int		i ;
unsigned short	*us_buf ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	us_buf = buf ;
	for( i=0,y=sy ; y<sy+height ; y++ ){
		for( x=sx ; x<sx+width ; x++ ){
			us_buf[i++] = pix_pt[x+y*vg_pt->width].a * 256 ;
		}
	}
}

